package com.jiuyu.wht_pay_plugin.handlers;


import com.jiuyu.wht_pay_plugin.ResultBean;
import com.tencent.mm.opensdk.constants.ConstantsAPI;
import com.tencent.mm.opensdk.modelbase.BaseResp;
import com.tencent.mm.opensdk.modelbiz.WXLaunchMiniProgram;

import io.flutter.plugin.common.EventChannel;
import io.flutter.plugin.common.MethodChannel;

public class SDPTHandler {

    private MethodChannel channel;
    private EventChannel.EventSink events;

    private static SDPTHandler singletonHandler = null;

    public static SDPTHandler getInstance() {
        if (null == singletonHandler) {
            synchronized (SDPTHandler.class) {
                if (null == singletonHandler) {
                    singletonHandler = new SDPTHandler();
                }
            }
        }
        return singletonHandler;
    }

    /**
     * 初始化参数
     */
    public void init (MethodChannel channel, EventChannel.EventSink eventSink){
        this.channel = channel;
        this.events = eventSink;
    }

    /**
     * 微信支付回调
     */
    public  void onResp(BaseResp resp){
        if (resp.getType() == ConstantsAPI.COMMAND_LAUNCH_WX_MINIPROGRAM) {
            WXLaunchMiniProgram.Resp launchMiniProResp = (WXLaunchMiniProgram.Resp) resp;
            String extraData = launchMiniProResp.extMsg; //对应小程序组件 <button open-type="launchApp"> 中的 app-parameter 属性
            //extraData: 0000支付成功，9999支付失败
//            channel.invokeMethod("onSDPTPayResponse",extraData);

            if (extraData.equals("0000")){
                ResultBean resultBean = new ResultBean(true,"02010005",extraData);
                events.success(resultBean.toJsonString());
            }else {
                ResultBean  resultBean = new ResultBean(false,"02010005",extraData);
                events.success(resultBean.toJsonString());
            }
        }else {
            ResultBean  resultBean = new ResultBean(false,"02010005","微信支付失败");
            events.success(resultBean.toJsonString());
        }
    }




}
