#import "WhtPayPlugin.h"
#import <UIKit/UIKit.h>
#import <SDPTLib/SDPTFramework.h>
#import <Security/Security.h>
#import <CommonCrypto/CommonDigest.h>
#import <UIView+PGToast.h>
#import "WXApi.h"
#import "UPPaymentControl.h"
#import "AFNetworking/AFNetworking.h"
@interface WhtPayPlugin()<FlutterStreamHandler,WXApiDelegate>


@end


/// 微信小程序原始id   益衫 gh_8f69bbed2867
#define ORIGID @"gh_8f69bbed2867"
/// 拉起小程序的类型 0 正式 1 开发  2 体验
#define TYPESMALLPR  @"0"



@implementation WhtPayPlugin{
    FlutterEventSink _eventSink;
    FlutterResult _result;
    FlutterMethodCall * _callData;
    NSString * _wx_app_id;///微信AppId
    XHPayParameterModel *configModel; ///初始化配置model
    NSString *product_code; ///当前支付类型code
    NSString *queryURL;///支付结果查询接口URL
}
+ (void)registerWithRegistrar:(NSObject<FlutterPluginRegistrar>*)registrar {
    WhtPayPlugin* instance = [[WhtPayPlugin alloc] init];
    FlutterMethodChannel* channel = [FlutterMethodChannel
      methodChannelWithName:@"sdp_pay"
            binaryMessenger:[registrar messenger]];
    FlutterEventChannel* chargingChannel = [FlutterEventChannel eventChannelWithName:@"sdp_pay/event" binaryMessenger: [registrar messenger]];
    [chargingChannel setStreamHandler:instance];
    [registrar addMethodCallDelegate:instance channel:channel];
    [registrar addApplicationDelegate:instance];
}

#pragma mark - IOS 主动发送通知s让 flutter调用监听 eventChannel start
- (FlutterError*)onListenWithArguments:(id)arguments eventSink:(FlutterEventSink)eventSink {
   _eventSink = eventSink;
    [self initSdk];
    return nil;
}
- (FlutterError*)onCancelWithArguments:(id)arguments {
  [[NSNotificationCenter defaultCenter] removeObserver:self];
  _eventSink = nil;
  return nil;
}
#pragma mark - flutter调用 oc eventChannel start
- (void)handleMethodCall:(FlutterMethodCall*)call result:(FlutterResult)result {
    _callData = call;
    _result = result;
  if ([@"getPlatformVersion" isEqualToString:call.method]) {
    result([@"iOS " stringByAppendingString:[[UIDevice currentDevice] systemVersion]]);
  }else if([@"init" isEqualToString:call.method]){
      [self initSdk];
  }else if ([@"payment" isEqualToString:call.method]){
      [self weixinclick];
  }
  else {
    result(FlutterMethodNotImplemented);
  }
}

- (void)initSdk{
    /// 打开日志
    [SDPTController shared].isLogEnable = YES;

    NSLog(@"_result = %@",_result);

    NSDictionary *dic = _callData.arguments;
    configModel = [XHPayParameterModel new];
    if (![dic objectForKey:@"store_id"] ||
        ![dic objectForKey:@"create_ip"] ||
        ![dic objectForKey:@"mer_no"] ||
        ![dic objectForKey:@"wx_app_id"] ||
        ![dic objectForKey:@"queryURL"]
        ) {
        NSLog(@"杉德SDK初始化失败+++++++++++++++++++++ = %@",dic);
        _result(@{@"state":@NO});

        return;
    }
    configModel.store_id = [dic objectForKey:@"store_id"];
    configModel.create_ip = [dic objectForKey:@"create_ip"];
    configModel.mer_no = [dic objectForKey:@"mer_no"];
    _wx_app_id = [dic objectForKey:@"wx_app_id"];
    queryURL = [dic objectForKey:@"queryURL"];
    NSLog(@"杉德SDK初始化参数成功+++++++++++++++++++++ = %@",dic);

    // app从后台进入前台都会调用这个方法
    [[NSNotificationCenter defaultCenter]removeObserver:self name:UIApplicationWillEnterForegroundNotification object:nil];


    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(applicationBecomeActive) name:UIApplicationWillEnterForegroundNotification object:nil];


    [WXApi startLogByLevel:WXLogLevelDetail logBlock:^(NSString *log) {
        NSLog(@"WeChatSDK: %@", log);
    }];

    /// 原生  移动应用id 需要在微信开发者平台处理得到  配置universalLink的Domain
    [WXApi registerApp:_wx_app_id
         universalLink:@"https://mmall.mixienet.com.cn/apple-app-site-association/"];
    _result(@{@"state":@YES});



}


///App从后台进入到前台的时候 根据需要请求判断支付宝支付状态
- (void)applicationBecomeActive{

    //20220216170302
    NSString *orderCode =  [[NSUserDefaults standardUserDefaults] objectForKey:@"alipaytoken_id"];
    if ([product_code isEqualToString:@"02020004"] && orderCode) {
        NSLog(@"App从后台进入到前台的时候 根据需要请求判断支付宝支付状态");
        AFHTTPSessionManager *manager =[AFHTTPSessionManager manager];
        manager.securityPolicy = [AFSecurityPolicy policyWithPinningMode:AFSSLPinningModeNone];
        manager.responseSerializer = [AFJSONResponseSerializer serializer];
        manager.requestSerializer = [AFJSONRequestSerializer serializer];
        [manager.requestSerializer setValue:@"application/json" forHTTPHeaderField:@"Accept"];
        [manager.requestSerializer setValue:@"application/json" forHTTPHeaderField:@"Content-Type"];
        [manager POST:queryURL parameters:@{@"orderCode" : orderCode,@"extend" : @""} headers:nil progress:^(NSProgress * _Nonnull uploadProgress) {

                } success:^(NSURLSessionDataTask * _Nonnull task, id  _Nullable responseObject) {

                    if (responseObject != [NSNull null]) {
                        NSDictionary *body = responseObject[@"body"];
                        NSString *status = body[@"orderStatus"];
                        if (status == nil || ![status isEqualToString:@"00"]) {//失败
                            [self callSinkResultIsSuccess:false payWay:self->product_code msg:@"支付宝支付失败！"];
                        }else{
                            [self callSinkResultIsSuccess:true payWay:self->product_code msg:@"支付宝支付成功！"];
                        }
                    }

                } failure:^(NSURLSessionDataTask * _Nullable task, NSError * _Nonnull error) {
                    [self callSinkResultIsSuccess:false payWay:self->product_code msg:@"支付宝支付失败！"];
                }];
    }
}


/// 微信
-(void)weixinclick{





    if (configModel == nil) {
        NSLog(@"未找到初始化参数");
        [[self getCurrentVC].view makeToast:@"未找到初始化参数"
                    duration:2
                    position:CSToastPositionCenter
                       style:[[CSToastStyle alloc] initWithDefaultStyle]];
        return;
    }

    NSDictionary *dic = _callData.arguments;

    if (dic == nil || dic == (id)[NSNull null]) {
        NSLog(@"未找到支付参数");
        return;
    }

    XHPayParameterModel *paymentModel = [XHPayParameterModel new];
    paymentModel.version = dic[@"version"];
    paymentModel.mer_no = dic[@"mer_no"];
    paymentModel.mer_order_no = dic[@"mer_order_no"];
    [self saveAliTokenForAueryResult:dic[@"mer_order_no"]];
    paymentModel.create_ip = dic[@"create_ip"];
    paymentModel.goods_name = dic[@"goods_name"];
    paymentModel.pay_extraJson = dic[@"pay_extra"];
    paymentModel.store_id = dic[@"store_id"];

    paymentModel.mer_key = dic[@"mer_key"];
    paymentModel.expire_time = dic[@"expire_time"];
    paymentModel.create_time = dic[@"create_time"];
    paymentModel.notify_url = dic[@"notify_url"];

    paymentModel.product_code = dic[@"product_code"];
    product_code = dic[@"product_code"];

    paymentModel.accsplit_flag = dic[@"accsplit_flag"];
    paymentModel.return_url = dic[@"return_url"];
    paymentModel.clear_cycle = dic[@"clear_cycle"];
    paymentModel.order_amt = dic[@"order_amt"];
    paymentModel.jump_scheme = dic[@"jump_scheme"];

    paymentModel.sign_type = dic[@"sign_type"];
    paymentModel.sign = dic[@"sign"];
    paymentModel.limit_pay = dic[@"limit_pay"];



    //需要判断是否安装试支付宝或者微信才能正常拉起App
    if ([product_code isEqualToString:@"02020004"] ) {
        if (![[UIApplication sharedApplication] canOpenURL:[NSURL URLWithString:@"alipay://"]]) {
            NSLog(@"未安装了支付宝APP");
            UIAlertController *alertCtr = [UIAlertController alertControllerWithTitle:@"温馨提示" message:@"请先安装支付宝App再试！" preferredStyle:UIAlertControllerStyleAlert];
            UIAlertAction *sure = [UIAlertAction actionWithTitle:@"确定" style:UIAlertActionStyleDefault handler:^(UIAlertAction * _Nonnull action) {
                NSString *url = @"https://apps.apple.com/cn/app/id333206289";
                url = [url stringByAddingPercentEscapesUsingEncoding:NSUTF8StringEncoding];
                [[UIApplication sharedApplication] openURL:[NSURL URLWithString:url]];

            }];
            [alertCtr addAction:sure];
            [[self getCurrentVC] presentViewController:alertCtr animated:YES completion:nil];
        }
    }else if([product_code isEqualToString:@"02010005"]){
        if (![[UIApplication sharedApplication] canOpenURL:[NSURL URLWithString:@"weixin://"]]) {
            NSLog(@"未安装了微信APP");
            UIAlertController *alertCtr = [UIAlertController alertControllerWithTitle:@"温馨提示" message:@"请先安装微信App再试！" preferredStyle:UIAlertControllerStyleAlert];
            UIAlertAction *sure = [UIAlertAction actionWithTitle:@"确定" style:UIAlertActionStyleDefault handler:^(UIAlertAction * _Nonnull action) {
                NSString *url = @"https://apps.apple.com/cn/app/id414478124";
                url = [url stringByAddingPercentEscapesUsingEncoding:NSUTF8StringEncoding];
                [[UIApplication sharedApplication] openURL:[NSURL URLWithString:url]];
            }];
            [alertCtr addAction:sure];
            [[self getCurrentVC] presentViewController:alertCtr animated:YES completion:nil];
        }
    }

    /// 展示收银台 只要微信编码
    [[SDPTController shared]showSDPTDesktopIn:[self getCurrentVC] model:paymentModel];

    /// 点击支付报错
    [SDPTController shared].payfailureBlock = ^(NSString * messageStr,ProductPyType typeStr){
       // NSLog(@"调取统一 支付  错误 信息 -- 错误类型 - - %@- -%ld",messageStr,typeStr);
        [self callSinkResultIsSuccess:false payWay:self->product_code msg:messageStr];
    };

    [SDPTController shared].payTypeBlock = ^(ProductPyType  type,NSString * tokenid){
       // NSLog(@" - - 支付类型- - - %ld  - -%lu数 tokenId --  %@",type,tokenid);

        if (type == PyTypeWeiXP) {
            [self  selectWxPay:tokenid];
        }else if (type == PyTypeZFBP){
            NSLog(@"调取 支付tokenid=%@",tokenid);
        }else if (type == PyTypeUnionP){
            NSLog(@"调取银联支付tokenid=%@",tokenid);
            /// 正确拿到银联的Tn
            // 00 生产 新版本的银联 可以直接吊起 云闪付和一些银行的app直接支付
            [[UPPaymentControl defaultControl]startPay:tokenid fromScheme:@"UPPayDemo" mode:@"00" viewController:[self getCurrentVC]];

        }else if (type == PyTypeLinkP){
            NSLog(@"链接 支付tokenid=%@",tokenid);
            [[self getCurrentVC].view makeToast:@"链接已经复制，请去微信支付宝或浏览器粘贴"
                        duration:2
                        position:CSToastPositionCenter
                           style:[[CSToastStyle alloc] initWithDefaultStyle]];
        }
    };


}

/// 微信支付 吊起  小程序支付
/// @param tokenID  微信tokenId
-(void)selectWxPay:(NSString *)tokenID {

    // 缓存 tokenid 拼接小程序链接
    NSUserDefaults *userDefault = [NSUserDefaults standardUserDefaults];
    [userDefault setObject:tokenID forKey:@"wxtoken_id"];

    NSString * allPath = [NSString stringWithFormat:@"pages/zf/index?token_id=%@",tokenID];
    NSLog(@"%@",allPath);
    WXLaunchMiniProgramReq *launchMiniProgramReq = [WXLaunchMiniProgramReq object];
    launchMiniProgramReq.userName = ORIGID;
    launchMiniProgramReq.path = allPath;
    /// 0 正式版
    launchMiniProgramReq.miniProgramType = TYPESMALLPR.integerValue;

    [WXApi sendReq:launchMiniProgramReq completion:^(BOOL success) {


    }];
//#warning  注意 在小程序中点击返回APP，返回使用 的是移动应用id做url-type跳回的scheme 写错的话 在微信中支付完成跳不回去 url type里面需要改成小程序的id

}
-(void)shard:(NSString*)tokenid {



    NSLog(@"链接已经复制，请去微信支付宝或浏览器粘贴");
    NSString *shareText = @"分享";
    UIImage *shareImage = [UIImage imageNamed:@"271610093376_.pic_hd"];
    NSURL *shareURL = [NSURL URLWithString:tokenid];
    NSArray *activityItems = [[NSArray alloc] initWithObjects:shareText, shareImage, shareURL, nil];

    UIActivityViewController *vc = [[UIActivityViewController alloc] initWithActivityItems:activityItems applicationActivities:nil];

    UIActivityViewControllerCompletionWithItemsHandler myBlock = ^(UIActivityType activityType, BOOL completed, NSArray *returnedItems, NSError *activityError) {
        NSLog(@"%@",activityType);
        if (completed) {
            NSLog(@"分享成功");
        } else {
            NSLog(@"分享失败");
        }
        [vc dismissViewControllerAnimated:YES completion:nil];
    };

    vc.completionWithItemsHandler = myBlock;

    [[self getCurrentVC] presentViewController:vc animated:YES completion:nil];

}

///  支付宝 支付结果拿不到 需要记录 下单信息 调查询接口拿到支付结果
-(void)saveAliTokenForAueryResult:(NSString *)tokenId {

    /// 存储token_id字段，用来调取查询支付结果的接口。
    NSLog(@"调取支付宝支付tokenid=%@",tokenId);

    NSUserDefaults *userDefault = [NSUserDefaults standardUserDefaults];
    [userDefault setObject:tokenId forKey:@"alipaytoken_id"];

}


- (BOOL)isBlankString:(NSString *)aStr {
    if (!aStr) {
        return YES;
    }
    if ([aStr isKindOfClass:[NSNull class]]) {
        return YES;
    }
    if (!aStr.length) {
        return YES;
    }
    NSCharacterSet *set = [NSCharacterSet whitespaceAndNewlineCharacterSet];
    NSString *trimmedStr = [aStr stringByTrimmingCharactersInSet:set];
    if (!trimmedStr.length) {
        return YES;
    }
    return NO;
}

//md5加密方式 参考。
- (NSString *)MD5_32BIT:(NSString *) input {
    const char *cStr = [input UTF8String];
    unsigned char digest[CC_MD5_DIGEST_LENGTH];
    CC_MD5( cStr, (CC_LONG)input.length, digest );
    NSMutableString *result = [NSMutableString stringWithCapacity:CC_MD5_DIGEST_LENGTH * 2];
    for(int i = 0; i < CC_MD5_DIGEST_LENGTH; i++)
        [result appendFormat:@"%02X", digest[i]];
    return result;

}

//普通回调
- (void)callResult:(NSString *)code msg:(NSString *)msg typeCode:(NSString *)typeCode{
    if (_result) {
        self->_result(@{
            @"code" : code,
            @"msg"  : msg,
            @"typeCode" : typeCode});
    }
}

/**
 *  支付结果
 *  boolean isSuccess
 *  String payWay  一个就支持一种  微信02010005 支付宝02020004  银联02030001  链接02000002 杉德宝02040001
 *  支付返回msg
 */
- (void)callSinkResultIsSuccess:(BOOL)isSuccess payWay:(NSString *)payWay msg:(NSString *)msg{
    if (_eventSink) {
        _eventSink(@{
            @"isSuccess" : [NSNumber numberWithBool:isSuccess],
            @"payWay"  : payWay,
            @"msg" : msg});
    }
}


- (BOOL)application:(UIApplication *)application openURL:(NSURL *)url sourceApplication:(NSString *)sourceApplication annotation:(id)annotation {
    return [WXApi handleOpenURL:url delegate:self];
}

// NOTE: 9.0以后使用新API接口
- (BOOL)application:(UIApplication *)app openURL:(NSURL *)url options:(NSDictionary<NSString *, id> *)options {
    /// 1. 杉德宝回调
//    if ([[SpsDock sharedInstance] canHandleUrl:url]) {
//        return  [[SpsDock sharedInstance] handleUrl:url];
//    }

    /// 2.银联支付结果回调
    [[UPPaymentControl defaultControl] handlePaymentResult:url completeBlock:^(NSString *code, NSDictionary *data) {
        //结果code为成功时，先校验签名，校验成功后做后续处理
        if([code isEqualToString:@"success"]) {
            [self callSinkResultIsSuccess:YES payWay:self->product_code msg:@"支付成功"];
//            //交易成功
//            //判断签名数据是否存在
//            if(data == nil){
//                //如果没有签名数据，建议商户app后台查询交易结果
//                [self callSinkResultIsSuccess:false payWay:self->product_code msg:@"如果没有签名数据，建议商户app后台查询交易结果"];
//                return;
//            }
//            //数据从NSDictionary转换为NSString
//            NSData *signData = [NSJSONSerialization dataWithJSONObject:data
//                                                               options:0
//                                                                error:nil];
//            NSString *sign = [[NSString alloc] initWithData:signData encoding:NSUTF8StringEncoding];
//
//
//            //验签证书同后台验签证书
//            //此处的verify，商户需送去商户后台做验签
//            if([self verify:sign]) {
//                //支付成功且验签成功，展示支付成功提示
//                [self callSinkResultIsSuccess:YES payWay:self->product_code msg:@"支付成功"];
//
//            }
//            else {
//                //验签失败，交易结果数据被篡改，商户app后台查询交易结果
//                [self callSinkResultIsSuccess:false payWay:self->product_code msg:@"验签失败，交易结果数据被篡改，商户app后台查询交易结果"];
//            }
        }else if([code isEqualToString:@"fail"]) {
            //交易失败
            NSLog(@" ---------------fail");
            [self callSinkResultIsSuccess:false payWay:self->product_code msg:@"交易失败"];
        }else if([code isEqualToString:@"cancel"]) {
            //交易取消
            NSLog(@" ---------------cancel");
            [self callSinkResultIsSuccess:false payWay:self->product_code msg:@"交易取消"];

        }
    }];

    /// 3.微信回调
    return  [WXApi handleOpenURL:url delegate:self];
}

#pragma mark 重写回调

- (BOOL)application:(UIApplication *)application continueUserActivity:(NSUserActivity *)userActivity restorationHandler:(void (^)(NSArray * _Nonnull))restorationHandler{
    return [WXApi handleOpenUniversalLink:userActivity delegate:self];
}
- (void)scene:(UIScene *)scene continueUserActivity:(NSUserActivity *)userActivity  API_AVAILABLE(ios(13.0)){
    [WXApi handleOpenUniversalLink:userActivity delegate:self];
}


#pragma mark - WXApiDelegate --- 微信小程序SDK返回支付结果代理回调 - - -

- (void)onResp:(BaseResp *)resp {

//    app分享到微信聊天，然后在聊天里面打开小程序，再跳转回app     if ([req isKindOfClass:[LaunchFromWXReq class]]) {

    // app直接打开微信小程序支付之后的返回app      if ([resp isKindOfClass:[WXLaunchMiniProgramResp class]]) {
 //  原生native 微信支付    if ([respisKindOfClass：[PayResp class]]){

    /// 微信小程序支付结果 打印 可以使用单例 代理出去 在你想要的VC 去拿到结果
    if([resp isKindOfClass:[WXLaunchMiniProgramResp class]]){
        //支付返回结果，实际支付结果需要去微信服务器端查询
        NSString *strMsg;
        WXLaunchMiniProgramResp *resp1 = (WXLaunchMiniProgramResp*)resp;

        switch (resp1.extMsg.integerValue) {

            case 0000:
                strMsg = resp1.extMsg;
                NSLog(@"支付成功－PaySuccess，retcode = %d", resp1.errCode);
                [self callSinkResultIsSuccess:true payWay:self->product_code msg:strMsg];
                break;
            case 9999:
                strMsg = resp1.extMsg;
                NSLog(@"支付取消－PaySuccess，retcode = %d", resp1.errCode);
                [self callSinkResultIsSuccess:false payWay:self->product_code msg:strMsg];
                break;

            default:
                strMsg = [NSString stringWithFormat:@"支付结果：失败！retcode = %d, retstr = %@", resp1.errCode,resp1.errStr];
                NSLog(@"错误，retcode = %d, retstr = %@", resp1.errCode,resp1.errStr);
                [self callSinkResultIsSuccess:false payWay:self->product_code msg:strMsg];
                break;
        }
    }else {

    }
}

-(BOOL) verify:(NSString *) resultStr {

    //验签证书同后台验签证书
    //此处的verify，商户需送去商户后台做验签
    return NO;
}

//当前显示的控制器

- (UIViewController *)getCurrentVC{
        UIViewController*result =nil;
        UIWindow * window = [[UIApplication sharedApplication] keyWindow];
        if (window.windowLevel != UIWindowLevelNormal)
        {NSArray*windows = [[UIApplication sharedApplication]windows];
        for(UIWindow* tmpWin in windows){
            if (tmpWin.windowLevel == UIWindowLevelNormal){
                window = tmpWin;break;}}
        }
       //从根控制器开始查找
        UIViewController*rootVC = window.rootViewController;
        id nextResponder = [rootVC.view nextResponder];
            if([nextResponder isKindOfClass:[UINavigationController class]]) {
               result = ((UINavigationController*)nextResponder).topViewController;
            if([result isKindOfClass:[UITabBarController class]]) {
                 result = ((UITabBarController*)result).selectedViewController;
            }
        }else if([nextResponder isKindOfClass:[UITabBarController class]]) {
               result = ((UITabBarController*)nextResponder).selectedViewController;
            if([result isKindOfClass:[UINavigationController class]]) {
               result = ((UINavigationController*)result).topViewController;
        }
        }else if([nextResponder isKindOfClass:[UIViewController class]]) {
                result = nextResponder;
        }else{result = window.rootViewController;
            if([result isKindOfClass:[UINavigationController class]]) {
                result = ((UINavigationController*)result).topViewController;
                if([result isKindOfClass:[UITabBarController class]]) {
                    result = ((UITabBarController*)result).selectedViewController;
                }
            }else if([result isKindOfClass:[UIViewController class]]) {
                 result = nextResponder;
            }
        };
    return  result;
}
@end
